
; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; -------------------------------------------------------------------
      ; Les fichiers inclus ii ,AUCUN .lib c'est au programme utilisateur
      ;	de les fournir
      ; -------------------------------------------------------------------
       include \masm32\include\windows.inc
       include \masm32\include\gdi32.inc
       include \masm32\include\user32.inc
      	include \masm32\include\kernel32.inc
	include \masm32\include\ole32.inc
	include \masm32\include\olepro32.inc
      ; include \masm32\include\masm32.inc
        include macros.txt	

      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------

      ; 
      ;exemples de definitions externes
      EXTERNDEF RetrouveMessageErreur :PROTO  :DWORD
      ; 	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
      ; 	EXTERNDEF PoriginePile:DWORD			

;dclarations interfaces

sIID_IPicture       TEXTEQU <{07BF80980H, 0BF32H, 0101AH,   \
                             {08BH, 0BBH, 000H, 0AAH, 000H, 030H, 00CH, 0ABH}}>
Load_IMAGE		PROTO :DWORD,:DWORD
Create_Bitmap		PROTO
                             
;C:\Program Files\Microsoft Platform SDK\Include\OCIdl.h	Ipicture
;C:\Program Files\Microsoft Platform SDK\Include\ObjIdl.h    Istream


pcomethod1	TYPEDEF PROTO :DWORD
pcomethod2	TYPEDEF PROTO :DWORD, :DWORD
pcomethod3	TYPEDEF PROTO :DWORD, :DWORD, :DWORD
pcomethod4	TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD
pcomethod5	TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD
pcomethod6	TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD
pcomethod7	TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD
pcomethod11	TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD, :DWORD , :DWORD ,:DWORD ,:DWORD
comethod1	TYPEDEF PTR pcomethod1
comethod2	TYPEDEF PTR pcomethod2
comethod3	TYPEDEF PTR pcomethod3
comethod4	TYPEDEF PTR pcomethod4
comethod5	TYPEDEF PTR pcomethod5
comethod6	TYPEDEF PTR pcomethod6
comethod7	TYPEDEF PTR pcomethod7
comethod11	TYPEDEF PTR pcomethod11


STIStream	STRUCT
;	Iunknown commune a toutes les interfaces
	QueryInterface       	comethod3       ?
	AddRef               	comethod1       ?
	Release              	comethod1       ?
	; ---ISequentialStream methods -------
	Read        		comethod4 ?
	Write       		comethod4 ?
	;------ IStream ----------------------	
	Seek                     comethod4 ?
	SetSize                  comethod2 ?
	CopyTo                   comethod5 ? 
	Commit                   comethod2 ?
	Revert                   comethod1 ?
	LockRegion               comethod4 ? 
	UnlockRegion             comethod4 ? 
	Stat                     comethod3 ? 
	Clone                    comethod2 ? 
STIStream	ENDS


STIPicture STRUCT
;	Iunknown commune a toutes les interfaces
	QueryInterface       	comethod3       ?
	AddRef               	comethod1       ?
	Release              	comethod1       ?
	; IPicture methods
	get_Handle        	comethod2       ?	;this,addr pHandle
	get_hPal          	comethod2       ?	;this,addr phPal
	get_Type          	comethod2       ?	;this,addr phPal
	get_Width         	comethod2       ?	;this,addr pWidth
	get_Height        	comethod2       ?	;this,addr pHeight
	Render            	comethod11      ?	;this,hdc,x,y,cx,cy,xSrc,ySrc,cxSrc,cySrc,addr pRcWBounds
	set_hPal          	comethod2       ?	;this,hPal
	get_CurDC         	comethod2       ?	;this,addr phDC
	SelectPicture     	comethod4       ?	;this,hDCIn,addr phDCOut,addr phBmpOut
	get_KeepOriginalFormat 	comethod2       ?	;this,addr pKeep
	put_KeepOriginalFormat	comethod2       ?	;this,keep
	PictureChanged        	comethod1       ?
	SaveAsFile            	comethod4       ?	;this,addr pStream,fSaveMemCopy,addr pCbSize
	get_Attributes        	comethod2       ?;this,addr pDwAtt
STIPicture ENDS

IPicture MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM

    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIPicture PTR[edx]).>,<&Function,ppvIPicture> 
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIPicture
    mov edx, [edx]
    InvokeInterface
ENDM	

IStream MACRO  Function:REQ, args:VARARG
	; definition de la macro locale InvokeInterface
    LOCAL InvokeInterface, arg
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM

    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (STIStream PTR[edx]).>,<&Function,ppvIStream> 
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	;   forme les lignes de codes
    mov edx, ppvIStream
    mov edx, [edx]
    InvokeInterface
ENDM	



HIMETRIC_INCH       EQU     2540



	
   .data	
ppvIPicture	dd 0
ppvIStream	dd 0

IID_IPicture        GUID    sIID_IPicture

    .code
;IN 0 ou 1 ;0 le deuxime argument est le numro d'une ressource
	   ;1 le deuxime argument est le nom d'un fichier
;IN numro de ressource ou adresse d'un nom de fichier

;OUT eax,handle d'un bitmap

;----- format d'images admis a l'entre BMP GIF JPG CUR ICO WMF

; #########################################################################

Load_IMAGE  PROC uses esi edi ebx step:dword,PolyValue:DWORD
		LOCAL PimageFile:DWORD,hModule:DWORD,hResource:DWORD
		LOCAL file:WIN32_FIND_DATA,pGlobal:DWORD,bytesread:DWORD
		LOCAL ofstruct:OFSTRUCT,Hfile:DWORD
		LOCAL retour:DWORD
		ZEROLOCALES retour
		
		mov retour,0	;echec par dfaut
	invoke GetModuleHandle,NULL
	mov hModule,eax
.if	step == 0	;c'est une ressource
	;
	invoke FindResource, hModule, PolyValue, SADR("IMAGE")
	.if eax == 0
		invoke RetrouveMessageErreur,SADR("FindResource failed")	
		jmp FindeLoad_IMAGE
	.endif
	mov hResource, eax
	invoke LoadResource,hModule, hResource
	invoke LockResource, eax
	mov PimageFile, eax
	invoke SizeofResource, hModule, hResource
	mov file.nFileSizeLow, eax
	.if eax == 0
		invoke RetrouveMessageErreur,SADR("SizeofResource failed")	
		jmp FindeLoad_IMAGE		
	.endif
.elseif step == 1	;c'est un fichier
	;se contenter de vrifier son existence et sa taille pour le charger
	;directement en mmoire par la suite
	invoke FindFirstFile,PolyValue,addr file
	.if eax == INVALID_HANDLE_VALUE
		invoke RetrouveMessageErreur,SADR("SizeofResource failed")	
		jmp FindeLoad_IMAGE				
	.else
		invoke FindClose,eax
	.endif

.else
;pas de rponse , mauvaise entre
	invoke SetLastError, ERROR_INVALID_FUNCTION	;sera traduite dans la langue
	invoke RetrouveMessageErreur,SADR("SizeofResource failed")	
	jmp FindeLoad_IMAGE
.endif

;------- on va pouvoir charger le fichier pour qu'il soit utilisable par Ipicture
	invoke CoTaskMemAlloc,file.nFileSizeLow  ; 
	.if eax == 0
		invoke RetrouveMessageErreur,SADR("SizeofResource failed")	
		jmp FindeLoad_IMAGE		
	.endif	
	mov pGlobal,eax

.if 	  step == 0
	mov esi,PimageFile
	mov edi,eax
	mov ecx,file.nFileSizeLow
	shr ecx,2	;divise par 4,ignore reste
	rep movsd
	mov ecx,file.nFileSizeLow
	and ecx,3	;recupre le reste
	.if ecx != 0
		rep movsb	
	.endif
	
.elseif step == 1
	mov ofstruct.cBytes,sizeof OFSTRUCT
	invoke OpenFile,PolyValue,addr ofstruct,OF_READ	
	mov Hfile,eax
	
	invoke ReadFile,Hfile,pGlobal,file.nFileSizeLow,addr bytesread,NULL
	.if eax != TRUE || bytesread == 0
		invoke RetrouveMessageErreur,SADR("SizeofResource failed")	
		jmp FindeLoad_IMAGE			
	.endif
	invoke CloseHandle,Hfile
.endif
	;on a une mmoire accessible par COM
	; create a stream for the picture object's creator
	invoke CreateStreamOnHGlobal, pGlobal, TRUE, ADDR ppvIStream
	mov edx,ppvIStream
	.if eax != S_OK	|| ppvIStream == 0
		invoke CoTaskMemFree,pGlobal
		jmp FindeLoad_IMAGE
	.endif
	;--------- ppv de Ipicture ------------------------------------------------
	invoke OleLoadPicture,ppvIStream, NULL, TRUE, ADDR IID_IPicture, ADDR ppvIPicture
	mov edx,ppvIPicture
	.if eax != S_OK  || ppvIPicture == 0
		IStream Release
		jmp FindeLoad_IMAGE
	.endif	
	;IStream et IPicture sont initialiss
	invoke Create_Bitmap		
	mov retour,eax
	;invoke ImageFromMemory, PimageFile,file.nFileSizeLow

FindeLoad_IMAGE:
	;Release compte le nombre d'appel,quand 0 libre mmoire
	.if ppvIStream != 0
		IStream Release
	.endif
	.if ppvIPicture != 0
		IPicture Release
	.endif
	
	mov eax,retour
	ret 
	               
Load_IMAGE  ENDP    
;---------- les donnes ont dja t transmises aux interfaces  -------------
;-------------------------------------------------------------------------------
Create_Bitmap PROC 
	LOCAL HcompatibleDC:DWORD,OldBitmap:DWORD,Hbitmap:DWORD
	LOCAL dwWidth:DWORD, dwHeight:DWORD,    Hdc:DWORD
	LOCAL hmWidth:DWORD, hmHeight:DWORD,    neghmHeight:DWORD
	ZEROLOCALES Hbitmap
	
	;----- creer un espace graphique pour pouvoir retravailler l'image
	mov Hdc,FUNC(GetDC, NULL)          ; screen DC	
	;------- 
	invoke CreateCompatibleDC, Hdc
	.IF eax == 0
		jmp FindeCreate_Bitmap
	.else
		mov HcompatibleDC, eax
	.ENDIF

	IPicture get_Width,addr hmWidth
	IPicture get_Height,addr hmHeight

	; convert himetric to pixels
	invoke GetDeviceCaps, Hdc, LOGPIXELSX
	invoke MulDiv, hmWidth, eax, HIMETRIC_INCH
	mov dwWidth, eax

	invoke GetDeviceCaps, Hdc, LOGPIXELSY
	invoke MulDiv, hmHeight, eax, HIMETRIC_INCH
	mov dwHeight, eax
	xor eax, eax
	sub eax, hmHeight
	mov neghmHeight, eax

	invoke CreateCompatibleBitmap, Hdc, dwWidth, dwHeight
	.IF eax == 0
		jmp FindeCreate_Bitmap
	.endif
	mov Hbitmap,eax
	invoke SelectObject, HcompatibleDC, Hbitmap
	.IF eax == 0
		invoke DeleteObject, Hbitmap
		mov Hbitmap,0
		jmp FindeCreate_Bitmap
	.ENDIF
	mov OldBitmap, eax

	;---------------------------------------------------------------------------------
	IPicture Render,HcompatibleDC,0,0,dwWidth,dwHeight,0,hmHeight,hmWidth,neghmHeight,0
	.IF eax != S_OK
		invoke SetLastError, eax
		invoke DeleteObject,Hbitmap
		mov Hbitmap,0
		jmp FindeCreate_Bitmap
	.ENDIF

	FindeCreate_Bitmap:
	.if Hdc != 0
		invoke ReleaseDC,NULL,Hdc
		.if	HcompatibleDC != 0
			invoke SelectObject, HcompatibleDC, OldBitmap		
			invoke DeleteDC, HcompatibleDC		
		.endif
	.endif
	mov eax,Hbitmap
	ret
Create_Bitmap ENDP                


; #########################################################################

end